## mingw-w64-opencollada-1.6.68-6.src.tar.zst

=== CMakeLists.txt ===
EXECUTE_PROCESS( COMMAND uname -m COMMAND tr -d '\n' OUTPUT_VARIABLE ARCHITECTURE )
message( STATUS "Architecture: ${ARCHITECTURE}" )

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	if(NOT DEFINED WITH_IN_SOURCE_BUILD)
		message(FATAL_ERROR
			"CMake generation for OpenCollada is not allowed within the source directory!"
			"\n Remove the CMakeCache.txt file and try again from another folder, e.g.:"
			"\n "
			"\n rm CMakeCache.txt"
			"\n cd .."
			"\n mkdir cmake-make"
			"\n cd cmake-make"
			"\n cmake ../opencollada"
			"\n "
			"\n Alternately define WITH_IN_SOURCE_BUILD to force this option (not recommended!)"
		)
	endif()
endif()

cmake_minimum_required(VERSION 2.6)


#-----------------------------------------------------------------------------
# Set policy.

# see "cmake --help-policy CMP0003"
# So library linking is more sane
cmake_policy(SET CMP0003 NEW)

# So defines are automatically quoted
cmake_policy(SET CMP0005 NEW)

# So syntax problems are errors
cmake_policy(SET CMP0010 NEW)

# Input directories must have CMakeLists.txt
cmake_policy(SET CMP0014 NEW)

# avoid having empty buildtype
set(CMAKE_BUILD_TYPE_INIT "Release")

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "Only do Release and Debug" FORCE )
mark_as_advanced(CMAKE_CONFIGURATION_TYPES)

SET(CMAKE_DEBUG_POSTFIX ""  CACHE STRING "Add this string to as suffix to Debug libraries, e.g.: xml2_d.lib " )

#-----------------------------------------------------------------------------
# Macro's

macro(opencollada_add_lib
	name
	sources
	target_libs
	)

	link_directories(${LIBRARY_OUTPUT_PATH})

	if (USE_STATIC)
		add_library(${name}_static STATIC ${sources})
		set_target_properties(${name}_static PROPERTIES OUTPUT_NAME ${name})
		foreach(target_lib ${target_libs})
			if(TARGET ${target_lib}_static)
				target_link_libraries(${name}_static ${target_lib}_static)
			else()
				target_link_libraries(${name}_static ${target_lib})
			endif()
			if( ${ARCHITECTURE} MATCHES "mips" )
				if(TARGET OpenCOLLADASaxFrameworkLoader_static)
					SET_TARGET_PROPERTIES(OpenCOLLADASaxFrameworkLoader_static PROPERTIES COMPILE_FLAGS "-Umips")
				endif()
			endif()
		endforeach()
		set(CMAKE_REQUIRED_LIBRARIES "${name}_static;${CMAKE_REQUIRED_LIBRARIES}" PARENT_SCOPE)

		install(
			TARGETS ${name}_static EXPORT LibraryExport
			ARCHIVE DESTINATION ${OPENCOLLADA_INST_LIBRARY}
		)
	endif ()

	if (USE_SHARED)
		if (NOT UNIX)
			message(${name} " WARNING: Shared library support implemented for UNIX-like OS only")
		endif ()
		add_library(${name}_shared SHARED ${sources})
		set_target_properties(${name}_shared PROPERTIES OUTPUT_NAME ${name})
		foreach(target_lib ${target_libs})
			if(TARGET ${target_lib}_shared)
				target_link_libraries(${name}_shared ${target_lib}_shared)
			else()
				target_link_libraries(${name}_shared ${target_lib})
			endif()
			if( ${ARCHITECTURE} MATCHES "mips" )
				if(TARGET OpenCOLLADASaxFrameworkLoader_shared)
					SET_TARGET_PROPERTIES(OpenCOLLADASaxFrameworkLoader_shared PROPERTIES COMPILE_FLAGS "-Umips")
				endif()
			endif()
		endforeach()
		set(CMAKE_REQUIRED_LIBRARIES "${name}_shared;${CMAKE_REQUIRED_LIBRARIES}"  PARENT_SCOPE)

		install(
			TARGETS ${name}_shared EXPORT LibraryExport
			LIBRARY DESTINATION ${OPENCOLLADA_INST_LIBRARY}
		)
	endif ()
endmacro()


# ---------------------
# copied from blender's
# build_files/cmake/macros.cmake

macro(ADD_CHECK_C_COMPILER_FLAG
	_CFLAGS
	_CACHE_VAR
	_FLAG)

	include(CheckCCompilerFlag)

	CHECK_C_COMPILER_FLAG("${_FLAG}" "${_CACHE_VAR}")
	if(${_CACHE_VAR})
		# message(STATUS "Using CFLAG: ${_FLAG}")
		set(${_CFLAGS} "${${_CFLAGS}} ${_FLAG}")
	else()
		message(STATUS "Unsupported CFLAG: ${_FLAG}")
	endif()
endmacro()

macro(ADD_CHECK_CXX_COMPILER_FLAG
	_CXXFLAGS
	_CACHE_VAR
	_FLAG)

	include(CheckCXXCompilerFlag)

	CHECK_CXX_COMPILER_FLAG("${_FLAG}" "${_CACHE_VAR}")
	if(${_CACHE_VAR})
		# message(STATUS "Using CXXFLAG: ${_FLAG}")
		set(${_CXXFLAGS} "${${_CXXFLAGS}} ${_FLAG}")
	else()
		message(STATUS "Unsupported CXXFLAG: ${_FLAG}")
	endif()
endmacro()
# end copy
# --------

#-----------------------------------------------------------------------------
# Initialize project.

project(OPENCOLLADA)  # must be after setting cmake_configuration_types

set(EXTERNAL_LIBRARIES        	   ${OPENCOLLADA_SOURCE_DIR}/Externals)  # external libraries
set(CMAKE_MODULE_PATH "${EXTERNAL_LIBRARIES}/cmake-modules")

set(OPENCOLLADA_VERSION_MAJOR 0)
set(OPENCOLLADA_VERSION_MINOR 1)
set(OPENCOLLADA_VERSION_PATCH 0)
set(OPENCOLLADA_VERSION ${OPENCOLLADA_VERSION_MAJOR}.${OPENCOLLADA_VERSION_MINOR}.${OPENCOLLADA_VERSION_PATCH})


#-----------------------------------------------------------------------------
# Compiler warnings.

set(C_WARNINGS   "")
set(CXX_WARNINGS "")

if (CMAKE_COMPILER_IS_GNUCC)
	ADD_CHECK_C_COMPILER_FLAG(C_WARNINGS C_WARN_ALL -Wall)
	ADD_CHECK_C_COMPILER_FLAG(C_WARNINGS C_WARN_EXTRA -Wextra)
	ADD_CHECK_C_COMPILER_FLAG(C_WARNINGS C_WARN_NO_UNKNOWN_PRAGMAS -Wno-unknown-pragmas)
	ADD_CHECK_C_COMPILER_FLAG(C_WARNINGS C_WARN_NO_SWITCH -Wno-switch)
	ADD_CHECK_C_COMPILER_FLAG(C_WARNINGS C_WARN_NO_UNUSED_PARAMETER -Wno-unused-parameter)
	ADD_CHECK_C_COMPILER_FLAG(C_WARNINGS C_WARN_NO_IGNORED_QUALIFIERS -Wno-ignored-qualifiers)
endif ()
if (CMAKE_COMPILER_IS_GNUCXX)
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_ALL -Wall)
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_EXTRA -Wextra)
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_NO_UNKNOWN_PRAGMAS -Wno-unknown-pragmas)
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_NO_SWITCH -Wno-switch)
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_NO_REORDER -Wno-reorder)  # could be re-ordered but for now this is just noise.
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_NO_UNUSED_PARAMETER -Wno-unused-parameter)
	ADD_CHECK_CXX_COMPILER_FLAG(CXX_WARNINGS CXX_WARN_NO_IGNORED_QUALIFIERS -Wno-ignored-qualifiers)
endif ()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_WARNINGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX_WARNINGS}")


#-----------------------------------------------------------------------------
# Install vars

set(OPENCOLLADA_INST_INCLUDE ${CMAKE_INSTALL_PREFIX}/include/opencollada)
set(OPENCOLLADA_INST_LIBRARY ${CMAKE_INSTALL_PREFIX}/lib/opencollada)
set(OPENCOLLADA_INST_CMAKECONFIG ${OPENCOLLADA_INST_LIBRARY}/cmake)


#-----------------------------------------------------------------------------
# Redirect output files

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin CACHE INTERNAL "" FORCE )
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib CACHE INTERNAL "" FORCE )


#-----------------------------------------------------------------------------
# Set default config options

option(USE_STATIC "Build static libraries"  ON)
option(USE_SHARED "Build shared libraries"  OFF)
option(USE_LIBXML "Use LibXml2 parser"      ON)
option(USE_EXPAT  "Use expat parser"        OFF)
option(USE_STATIC_MSVC_RUNTIME "Use static version of the MSVC run-time library" OFF)

#adding xml2
if (USE_LIBXML)
	add_definitions(
		-DGENERATEDSAXPARSER_XMLPARSER_LIBXML
		-DXMLPARSER_LIBXML
	)
	find_package(LibXml2)
	if (LIBXML2_FOUND)
		message(STATUS "SUCCESSFUL: LibXml2 found")
	else ()  # if xml2 not found building its local copy from ./Externals
		if (WIN32)
			message("WARNING: Native LibXml2 not found, taking LibXml from ./Externals")
			add_subdirectory(${EXTERNAL_LIBRARIES}/LibXML)
			set(LIBXML2_INCLUDE_DIR
				${libxml_include_dirs}
			)
			set(LIBXML2_LIBRARIES xml)
		else ()
			message("ERROR: LibXml2 not found, please install xml2 library (for Debian libxml2-dev)")
		endif ()
	endif ()
endif ()

if (USE_EXPAT)
	add_definitions(-DGENERATEDSAXPARSER_XMLPARSER_EXPAT)
	message("FATAL: EXPAT support not implemented")
	# TODO:: use externals
endif ()

if(USE_STATIC_MSVC_RUNTIME)
	foreach(flag CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL
			CMAKE_CXX_FLAGS_RELWITHDEBINFO CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
			CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
		if(${flag} MATCHES "/MD")
			STRING(REGEX REPLACE "/MD" "/MT" ${flag} "${${flag}}")
		endif()
		if(${flag} MATCHES "/MDd")
			STRING(REGEX REPLACE "/MDd" "/MTd" ${flag} "${${flag}}")
		endif()
	endforeach()
endif()

#adding PCRE
find_package(PCRE)
if (PCRE_FOUND)
	message(STATUS "SUCCESSFUL: PCRE found")
else ()  # if pcre not found building its local copy from ./Externals
	if (WIN32 OR APPLE)
		message("WARNING: Native PCRE not found, taking PCRE from ./Externals")
		add_definitions(-DPCRE_STATIC)
		add_subdirectory(${EXTERNAL_LIBRARIES}/pcre)
		set(PCRE_INCLUDE_DIR ${libpcre_include_dirs})
		set(PCRE_LIBRARIES pcre)
	else ()
		message("ERROR: PCRE not found, please install pcre library")
	endif ()
endif ()

# building required libs
add_subdirectory(common/libftoa)
add_subdirectory(${EXTERNAL_LIBRARIES}/UTF)
add_subdirectory(common/libBuffer)
add_subdirectory(${EXTERNAL_LIBRARIES}/MathMLSolver)
add_subdirectory(${EXTERNAL_LIBRARIES}/zlib)

# building OpenCOLLADA libs
add_subdirectory(COLLADABaseUtils)
add_subdirectory(COLLADAFramework)
add_subdirectory(GeneratedSaxParser)
add_subdirectory(COLLADASaxFrameworkLoader)
add_subdirectory(COLLADAStreamWriter)

# building COLLADAValidator app
add_subdirectory(COLLADAValidator)

# DAE validator app
add_subdirectory(DAEValidator)

# Library export
install(EXPORT LibraryExport DESTINATION ${OPENCOLLADA_INST_CMAKECONFIG} FILE OpenCOLLADATargets.cmake)

# Create the configuration files
include(CMakePackageConfigHelpers)
configure_package_config_file(OpenCOLLADAConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/OpenCOLLADAConfig.cmake
                              INSTALL_DESTINATION ${OPENCOLLADA_INST_CMAKECONFIG}
                              PATH_VARS OPENCOLLADA_INST_INCLUDE OPENCOLLADA_INST_CMAKECONFIG
                              NO_SET_AND_CHECK_MACRO NO_CHECK_REQUIRED_COMPONENTS_MACRO)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/OpenCOLLADAConfigVersion.cmake
                                 VERSION ${OPENCOLLADA_VERSION}
                                 COMPATIBILITY SameMajorVersion)

# Install the configuration files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCOLLADAConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/OpenCOLLADAConfigVersion.cmake
        DESTINATION ${OPENCOLLADA_INST_CMAKECONFIG})

=== COLLADASaxFrameworkLoader/CMakeLists.txt ===
set(name OpenCOLLADASaxFrameworkLoader)
project(${name})

set(libSaxFrameworkLoader_include_dirs
	${CMAKE_CURRENT_SOURCE_DIR}/include
	${CMAKE_CURRENT_SOURCE_DIR}/include/generated14
	${CMAKE_CURRENT_SOURCE_DIR}/include/generated15
)

set(libSaxFrameworkLoader_include_dirs ${libSaxFrameworkLoader_include_dirs} PARENT_SCOPE)  # adding include dirs to a parent scope

set(INST_SRC
	include/COLLADASaxFWLAccessor.h
	include/COLLADASaxFWLArrayElement.h
	include/COLLADASaxFWLAssetLoader.h
	include/COLLADASaxFWLCOLLADACsymbol.h
	include/COLLADASaxFWLDocumentProcessor.h
	include/COLLADASaxFWLException.h
	include/COLLADASaxFWLExtraDataElementHandler.h
	include/COLLADASaxFWLExtraDataLoader.h
	include/COLLADASaxFWLFileLoader.h
	include/COLLADASaxFWLFilePartLoader.h
	include/COLLADASaxFWLFormulasLinker.h
	include/COLLADASaxFWLFormulasLoader.h
	include/COLLADASaxFWLGeometryLoader.h
	include/COLLADASaxFWLGeometryMaterialIdInfo.h
	include/COLLADASaxFWLHelperLoaderBase.h
	include/COLLADASaxFWLIError.h
	include/COLLADASaxFWLIErrorHandler.h
	include/COLLADASaxFWLIExtraDataCallbackHandler.h
	include/COLLADASaxFWLIFilePartLoader.h
	include/COLLADASaxFWLIParserImpl.h
	include/COLLADASaxFWLIParserImpl14.h
	include/COLLADASaxFWLIParserImpl15.h
	include/COLLADASaxFWLInputShared.h
	include/COLLADASaxFWLInputUnshared.h
	include/COLLADASaxFWLInstanceArticulatedSystemLoader.h
	include/COLLADASaxFWLInstanceKinematicsModelLoader.h
	include/COLLADASaxFWLIntermediateTargetable.h
	include/COLLADASaxFWLInterpolationTypeSource.h
	include/COLLADASaxFWLJointsLoader.h
	include/COLLADASaxFWLKinematicsIntermediateData.h
	include/COLLADASaxFWLKinematicsSceneCreator.h
	include/COLLADASaxFWLLibraryAnimationClipsLoader.h
	include/COLLADASaxFWLLibraryAnimationsLoader.h
	include/COLLADASaxFWLLibraryArticulatedSystemsLoader.h
	include/COLLADASaxFWLLibraryCamerasLoader.h
	include/COLLADASaxFWLLibraryControllersLoader.h
	include/COLLADASaxFWLLibraryEffectsLoader.h
	include/COLLADASaxFWLLibraryFormulasLoader.h
	include/COLLADASaxFWLLibraryImagesLoader.h
	include/COLLADASaxFWLLibraryJointsLoader.h
	include/COLLADASaxFWLLibraryKinematicsModelsLoader.h
	include/COLLADASaxFWLLibraryKinematicsScenesLoader.h
	include/COLLADASaxFWLLibraryLightsLoader.h
	include/COLLADASaxFWLLibraryMaterialsLoader.h
	include/COLLADASaxFWLLibraryNodesLoader.h
	include/COLLADASaxFWLLoader.h
	include/COLLADASaxFWLMeshLoader.h
	include/COLLADASaxFWLMeshPrimitiveInputList.h
	include/COLLADASaxFWLNodeLoader.h
	include/COLLADASaxFWLPHElement.h
	include/COLLADASaxFWLPolygons.h
	include/COLLADASaxFWLPostProcessor.h
	include/COLLADASaxFWLPrerequisites.h
	include/COLLADASaxFWLPrimitiveBase.h
	include/COLLADASaxFWLRootParser14.h
	include/COLLADASaxFWLRootParser15.h
	include/COLLADASaxFWLSaxFWLError.h
	include/COLLADASaxFWLSaxParserError.h
	include/COLLADASaxFWLSaxParserErrorHandler.h
	include/COLLADASaxFWLSceneLoader.h
	include/COLLADASaxFWLSidAddress.h
	include/COLLADASaxFWLSidTreeNode.h
	include/COLLADASaxFWLSource.h
	include/COLLADASaxFWLSourceArrayLoader.h
	include/COLLADASaxFWLSplineLoader.h
	include/COLLADASaxFWLStableHeaders.h
	include/COLLADASaxFWLTechniqueCommon.h
	include/COLLADASaxFWLTransformationLoader.h
	include/COLLADASaxFWLTypes.h
	include/COLLADASaxFWLUtils.h
	include/COLLADASaxFWLVersionParser.h
	include/COLLADASaxFWLVertices.h
	include/COLLADASaxFWLVisualSceneLoader.h
	include/COLLADASaxFWLXmlTypes.h
)

set(INST_GEN14_SRC
	include/generated14/COLLADASaxFWLAssetLoader14.h
	include/generated14/COLLADASaxFWLColladaParserAutoGen14.h
	include/generated14/COLLADASaxFWLColladaParserAutoGen14Attributes.h
	include/generated14/COLLADASaxFWLColladaParserAutoGen14Enums.h
	include/generated14/COLLADASaxFWLColladaParserAutoGen14FunctionMapFactory.h
	include/generated14/COLLADASaxFWLColladaParserAutoGen14Private.h
	include/generated14/COLLADASaxFWLColladaParserAutoGen14ValidationData.h
	include/generated14/COLLADASaxFWLGeometryLoader14.h
	include/generated14/COLLADASaxFWLLibraryAnimationClipsLoader14.h
	include/generated14/COLLADASaxFWLLibraryAnimationsLoader14.h
	include/generated14/COLLADASaxFWLLibraryCamerasLoader14.h
	include/generated14/COLLADASaxFWLLibraryControllersLoader14.h
	include/generated14/COLLADASaxFWLLibraryEffectsLoader14.h
	include/generated14/COLLADASaxFWLLibraryImagesLoader14.h
	include/generated14/COLLADASaxFWLLibraryLightsLoader14.h
	include/generated14/COLLADASaxFWLLibraryMaterialsLoader14.h
	include/generated14/COLLADASaxFWLLibraryNodesLoader14.h
	include/generated14/COLLADASaxFWLMeshLoader14.h
	include/generated14/COLLADASaxFWLNodeLoader14.h
	include/generated14/COLLADASaxFWLSceneLoader14.h
	include/generated14/COLLADASaxFWLSourceArrayLoader14.h
	include/generated14/COLLADASaxFWLSplineLoader14.h
	include/generated14/COLLADASaxFWLVisualSceneLoader14.h
)

set(INST_GEN15_SRC
	include/generated15/COLLADASaxFWLAssetLoader15.h
	include/generated15/COLLADASaxFWLColladaParserAutoGen15.h
	include/generated15/COLLADASaxFWLColladaParserAutoGen15Attributes.h
	include/generated15/COLLADASaxFWLColladaParserAutoGen15Enums.h
	include/generated15/COLLADASaxFWLColladaParserAutoGen15FunctionMapFactory.h
	include/generated15/COLLADASaxFWLColladaParserAutoGen15Private.h
	include/generated15/COLLADASaxFWLColladaParserAutoGen15ValidationData.h
	include/generated15/COLLADASaxFWLFormulasLoader15.h
	include/generated15/COLLADASaxFWLGeometryLoader15.h
	include/generated15/COLLADASaxFWLLibraryAnimationClipsLoader15.h
	include/generated15/COLLADASaxFWLLibraryAnimationsLoader15.h
	include/generated15/COLLADASaxFWLLibraryArticulatedSystemsLoader15.h
	include/generated15/COLLADASaxFWLLibraryCamerasLoader15.h
	include/generated15/COLLADASaxFWLLibraryControllersLoader15.h
	include/generated15/COLLADASaxFWLLibraryEffectsLoader15.h
	include/generated15/COLLADASaxFWLLibraryFormulasLoader15.h
	include/generated15/COLLADASaxFWLLibraryImagesLoader15.h
	include/generated15/COLLADASaxFWLLibraryJointsLoader15.h
	include/generated15/COLLADASaxFWLLibraryKinematicsModelsLoader15.h
	include/generated15/COLLADASaxFWLLibraryKinematicsScenesLoader15.h
	include/generated15/COLLADASaxFWLLibraryLightsLoader15.h
	include/generated15/COLLADASaxFWLLibraryMaterialsLoader15.h
	include/generated15/COLLADASaxFWLLibraryNodesLoader15.h
	include/generated15/COLLADASaxFWLMeshLoader15.h
	include/generated15/COLLADASaxFWLNodeLoader15.h
	include/generated15/COLLADASaxFWLSceneLoader15.h
	include/generated15/COLLADASaxFWLSourceArrayLoader15.h
	include/generated15/COLLADASaxFWLVisualSceneLoader15.h
)

set(SRC
	src/COLLADASaxFWLLibraryArticulatedSystemsLoader.cpp
	src/COLLADASaxFWLCOLLADACsymbol.cpp
	src/COLLADASaxFWLLibraryAnimationClipsLoader.cpp
	src/COLLADASaxFWLLibraryAnimationsLoader.cpp
	src/COLLADASaxFWLIParserImpl14.cpp
	src/COLLADASaxFWLTransformationLoader.cpp
	src/COLLADASaxFWLInputUnshared.cpp
	src/COLLADASaxFWLIFilePartLoader.cpp
	src/COLLADASaxFWLFilePartLoader.cpp
	src/COLLADASaxFWLGeometryMaterialIdInfo.cpp
	src/COLLADASaxFWLLibraryControllersLoader.cpp
	src/COLLADASaxFWLSaxParserError.cpp
	src/COLLADASaxFWLSaxFWLError.cpp
	src/COLLADASaxFWLSourceArrayLoader.cpp
	src/COLLADASaxFWLLibraryKinematicsScenesLoader.cpp
	src/COLLADASaxFWLExtraDataLoader.cpp
	src/COLLADASaxFWLLoader.cpp
	src/COLLADASaxFWLLibraryLightsLoader.cpp
	src/COLLADASaxFWLLibraryImagesLoader.cpp
	src/COLLADASaxFWLIParserImpl15.cpp
	src/COLLADASaxFWLJointsLoader.cpp
	src/COLLADASaxFWLKinematicsIntermediateData.cpp
	src/COLLADASaxFWLTypes.cpp
	src/COLLADASaxFWLNodeLoader.cpp
	src/COLLADASaxFWLAssetLoader.cpp
	src/COLLADASaxFWLRootParser14.cpp
	src/COLLADASaxFWLKinematicsSceneCreator.cpp
	src/COLLADASaxFWLIExtraDataCallbackHandler.cpp
	src/COLLADASaxFWLMeshPrimitiveInputList.cpp
	src/COLLADASaxFWLPrecompiledHeaders.cpp
	src/COLLADASaxFWLInstanceKinematicsModelLoader.cpp
	src/COLLADASaxFWLSaxParserErrorHandler.cpp
	src/COLLADASaxFWLLibraryNodesLoader.cpp
	src/COLLADASaxFWLRootParser15.cpp
	src/COLLADASaxFWLLibraryCamerasLoader.cpp
	src/COLLADASaxFWLFormulasLinker.cpp
	src/COLLADASaxFWLLibraryKinematicsModelsLoader.cpp
	src/COLLADASaxFWLLibraryFormulasLoader.cpp
	src/COLLADASaxFWLPostProcessor.cpp
	src/COLLADASaxFWLDocumentProcessor.cpp
	src/COLLADASaxFWLSceneLoader.cpp
	src/COLLADASaxFWLInstanceArticulatedSystemLoader.cpp
	src/COLLADASaxFWLFormulasLoader.cpp
	src/COLLADASaxFWLLibraryMaterialsLoader.cpp
	src/COLLADASaxFWLFileLoader.cpp
	src/COLLADASaxFWLMeshLoader.cpp
	src/COLLADASaxFWLVersionParser.cpp
	src/COLLADASaxFWLIError.cpp
	src/COLLADASaxFWLIErrorHandler.cpp
	src/COLLADASaxFWLLibraryEffectsLoader.cpp
	src/COLLADASaxFWLLibraryJointsLoader.cpp
	src/COLLADASaxFWLSidTreeNode.cpp
	src/COLLADASaxFWLSidAddress.cpp
	src/COLLADASaxFWLVisualSceneLoader.cpp
	src/COLLADASaxFWLGeometryLoader.cpp
	src/COLLADASaxFWLExtraDataElementHandler.cpp
	src/COLLADASaxFWLSplineLoader.cpp

	src/generated14/COLLADASaxFWLSplineLoader14.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14PrivateNameMap.cpp
	src/generated14/COLLADASaxFWLLibraryNodesLoader14.cpp
	src/generated14/COLLADASaxFWLGeometryLoader14.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14PrivateFunctionMapFactory.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14PrivateValidation.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14PrivateEnums.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14PrivateFunctionMap.cpp
	src/generated14/COLLADASaxFWLLibraryMaterialsLoader14.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14PrivateFindElementHash.cpp
	src/generated14/COLLADASaxFWLLibraryAnimationClipsLoader14.cpp
	src/generated14/COLLADASaxFWLLibraryAnimationsLoader14.cpp
	src/generated14/COLLADASaxFWLSceneLoader14.cpp
	src/generated14/COLLADASaxFWLAssetLoader14.cpp
	src/generated14/COLLADASaxFWLLibraryEffectsLoader14.cpp
	src/generated14/COLLADASaxFWLVisualSceneLoader14.cpp
	src/generated14/COLLADASaxFWLSourceArrayLoader14.cpp
	src/generated14/COLLADASaxFWLNodeLoader14.cpp
	src/generated14/COLLADASaxFWLLibraryControllersLoader14.cpp
	src/generated14/COLLADASaxFWLColladaParserAutoGen14Private.cpp
	src/generated14/COLLADASaxFWLLibraryCamerasLoader14.cpp
	src/generated14/COLLADASaxFWLMeshLoader14.cpp
	src/generated14/COLLADASaxFWLLibraryImagesLoader14.cpp
	src/generated14/COLLADASaxFWLLibraryLightsLoader14.cpp
	src/generated14/COLLADASaxFWLSplineLoader14.cpp

	src/generated15/COLLADASaxFWLNodeLoader15.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15PrivateNameMap.cpp
	src/generated15/COLLADASaxFWLMeshLoader15.cpp
	src/generated15/COLLADASaxFWLSceneLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryArticulatedSystemsLoader15.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15PrivateFindElementHash.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15PrivateFunctionMapFactory.cpp
	src/generated15/COLLADASaxFWLLibraryAnimationClipsLoader15.cpp	
	src/generated15/COLLADASaxFWLLibraryAnimationsLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryJointsLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryNodesLoader15.cpp
	src/generated15/COLLADASaxFWLSourceArrayLoader15.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15PrivateValidation.cpp
	src/generated15/COLLADASaxFWLLibraryKinematicsModelsLoader15.cpp
	src/generated15/COLLADASaxFWLVisualSceneLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryImagesLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryFormulasLoader15.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15Private.cpp
	src/generated15/COLLADASaxFWLFormulasLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryKinematicsScenesLoader15.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15PrivateFunctionMap.cpp
	src/generated15/COLLADASaxFWLGeometryLoader15.cpp
	src/generated15/COLLADASaxFWLColladaParserAutoGen15PrivateEnums.cpp
	src/generated15/COLLADASaxFWLLibraryLightsLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryEffectsLoader15.cpp
	src/generated15/COLLADASaxFWLAssetLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryCamerasLoader15.cpp
	src/generated15/COLLADASaxFWLLibraryMaterialsLoader15.cpp

=== COLLADAValidator/CMakeLists.txt ===
set(name OpenCOLLADAValidator)
project(${name})

set(libValidator_include_dirs
	${CMAKE_CURRENT_SOURCE_DIR}/include
)

set(libValidator_include_dirs ${libValidator_include_dirs} PARENT_SCOPE)  # adding include dirs to a parent scope

set(SRC
	src/main.cpp
	src/ValidationErrorHandler.cpp
	
	include/ValidationErrorHandler.h
	include/Writer.h
)

set(libValidator_libs
	OpenCOLLADASaxFrameworkLoader
	GeneratedSaxParser
	OpenCOLLADAFramework
	OpenCOLLADABaseUtils
	MathMLSolver
	${PCRE_LIBRARIES}
	${LIBXML2_LIBRARIES}
	UTF
)

if (WIN32)
    set(libValidator_libs ${libValidator_libs}
        ws2_32.lib
    )
endif ()

include_directories(
	${libValidator_include_dirs}
	${libBaseUtils_include_dirs}
	${libFramework_include_dirs}
	${libSaxFrameworkLoader_include_dirs}
	${libGeneratedSaxParser_include_dirs}
)

SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
link_directories(${LIBRARY_OUTPUT_PATH})

add_executable(${name} ${SRC})
target_link_libraries(${name} ${libValidator_libs})
add_dependencies(${name} ${CMAKE_REQUIRED_LIBRARIES})

if (NOT LIBXML2_FOUND)
	add_definitions(
		-DLIBXML_AUTOMATA_ENABLED
        -DLIBXML_HTTP_ENABLED
		-DLIBXML_PATTERN_ENABLED
		-DLIBXML_REGEXP_ENABLED
		-DLIBXML_SCHEMAS_ENABLED
		-DLIBXML_XPATH_ENABLED
		)
	if (USE_STATIC)
		add_dependencies(${name} xml_static)
	endif ()
	if (USE_SHARED)
		add_dependencies(${name} xml_shared)
	endif ()
endif ()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=opencollada
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}-git")
replaces=("${MINGW_PACKAGE_PREFIX}-${_realname}-git")
pkgver=1.6.68
pkgrel=6
pkgdesc="Stream based reader and writer library for COLLADA files (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/khronosGroup/OpenCOLLADA/"
msys2_references=(
  'archlinux: opencollada'
)
license=("spdx:MIT")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-pcre")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/KhronosGroup/OpenCOLLADA/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        fix-mingw-w64.patch
        fix-missing-include.patch
        fix-inttypes-mingw.patch
        fix-pcre-type-conflict.patch
        opencollada-cmake.patch
        opencollada-disable-test-mingw.patch
        use-cpp-headers.patch
        move-hash-function.patch
        disable-indentation-warnings.patch
        010-fix-unordered.patch
        011-fix-build-with-gcc-15.patch)
sha256sums=('d9db0c0a518aa6ac0359626f222707c6ca1b63a83cbf229d97a5999c9cde347b'
            '10fdc2746b83161b853df6ad4ac600252c4f964377ea0186ff97f99bd3417e34'
            '18f1bf9f57d1c67aa35927fb0d1b0b38def52b189742021f1268eb2bdbffc963'
            '6fb7cf3116bdcb93af58a2487c44b298afd11e83c21ec87a8c921eda6dcba766'
            'be24a0ccaee8f2db24acafd378326cec8f3a57cf95a5575ae613886fda68dd4a'
            '80964043f2d91b4433c455a8198bb9cb29c1a621c844b08e4e447d21bb4d41a7'
            'a0eb0e2385897cd2b7e1335229128ceda0f607aa6d8f50ad152d3236811488d6'
            '8ba7875069585e99f9ebd5044ae10c7a92af5d5a7cfcd61cf69ab24cc70cddc3'
            '93eaf5c565ff30d8d37f1055a432e9516dd518ee040e9384633f55d4a9c305ca'
            '4fc1d79fc2965c4fbebb9e25d174eb48b91a2d93601dfc5417c90acd88909495'
            'c58ec624031b8dfa0393c138eaf23418850a59d3b7478f2e064dba8553a58b54'
            'a22fd084d3d19ee4877c9274ef5ff7c278cb7a0e336542fa37048662f8246ff9')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  apply_patch_with_msg \
    fix-mingw-w64.patch \
    fix-missing-include.patch \
    fix-inttypes-mingw.patch \
    fix-pcre-type-conflict.patch \
    opencollada-cmake.patch \
    opencollada-disable-test-mingw.patch \
    use-cpp-headers.patch \
    move-hash-function.patch \
    disable-indentation-warnings.patch \
    010-fix-unordered.patch \
    011-fix-build-with-gcc-15.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
     -G"Ninja" \
     -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
     -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
     -DUSE_SHARED=ON \
     ${extra_config} \
     ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  # replace absolute paths in .cmake scripts
  sed -i "s;$(cygpath -ma "${MINGW_PREFIX}");\${_IMPORT_PREFIX};" "${pkgdir}${MINGW_PREFIX}/lib/cmake/OpenCOLLADA"/*Targets*.cmake
}
